//+------------------------------------------------------------------+
//|                                               Marti_Orel_v01.mq4 |
//|                                          Copyright  2007, Silem |
//|                                                     silem@k66.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Silem"
#property link      "silem@k66.ru"
#include <stdlib.mqh>


//---- input parameters
extern int       TP=20;
extern int       SL=40;
extern int       Step=20;
extern double    Lot=0.01;
extern int       UseMM=1;
extern int       IniBal=1000;
extern double    Multiplier=2;
// extern int       NeedProf=10;
extern int       MN=100;
// extern int       NumberOfSteps=10;
extern int       EntryMode=2; // 1 - MA slope, 2 - price against MA
extern int       MA_TF=0;
extern int       MA_Per=100;
extern int       MA_Method=3; // MODE_SMA 0, MODE_EMA 1, MODE_SMMA 2, MODE_LWMA 3 
extern int       MA_ApplPrice=4; //PRICE_CLOSE 0, PRICE_OPEN 1, PRICE_HIGH 2, PRICE_LOW 3, PRICE_MEDIAN 4, (high+low)/2, PRICE_TYPICAL 5, (high+low+close)/3, PRICE_WEIGHTED 6 (high+low+close+close)/4 
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
 {
//----
  int T=0, n=0, s=0;
  bool enterBuy=false;
  bool enterSell=false;
  double _spr=Ask-Bid;
  int ticket, err;
  bool tic;
 // it's a block for entry point
  
  if (EntryMode==1)
   {
    double MA1=iMA(Symbol(),MA_TF,MA_Per,0,MA_Method,MA_ApplPrice,1);
    double MA2=iMA(Symbol(),MA_TF,MA_Per,0,MA_Method,MA_ApplPrice,2);
    if (MA1>MA2)
     {
      enterBuy=true;
     } else
     {
      enterSell=true;
     }
   }
  if (EntryMode==2)
   {
    MA1=iMA(Symbol(),MA_TF,MA_Per,0,MA_Method,MA_ApplPrice,1);
    if (Close[1]>MA1)
     {
      enterBuy=true;
     } else
     {
      enterSell=true;
     }
   }

 // end of block


  if (UseMM==1) 
   {
    double InitLots=MathCeil(AccountBalance()/IniBal)/100;
   } else
   {
    InitLots=Lot;
   }
  if (InitLots<0.01) InitLots=0.01;
  for(int i=0;i<OrdersTotal();i++)
   { 
    OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN) 
     {
      T++;
      if(OrderType()==OP_BUY) 
       {
        s=1;
        double LastBuy=OrderOpenPrice();
        double LastBuyLot=OrderLots();
       }
      if(OrderType()==OP_SELL)
       {
        s=2;
        double LastSell=OrderOpenPrice();
        double LastSellLot=OrderLots();
       }
      if(OrderType()!=OP_SELL && OrderType()!=OP_BUY)
       {
        n=1;
       }
     } //     -  , s=1 -  , s=2 -      
   }
  if (s==0 && n==1)
   {
    for(i=OrdersTotal()-1;i>=0;i--)
     { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN && OrderType()!=OP_BUY && OrderType()!=OP_SELL)
       {
        tic=OrderDelete(OrderTicket());
        if (!tic) 
         {
          err=GetLastError();
          Print("   ", ErrorDescription(err));
         }
       }
     } 
   }
  if (T==0 && n==0)
   {
    RefreshRates();
    if (enterBuy)
     {
      ticket=OrderSend(Symbol(),OP_BUY,InitLots,Ask,3,Ask-SL*Point-_spr,Ask+TP*Point,"First Buy",MN,0,Blue);
      if (ticket<0) 
       {
        err=GetLastError();
        Print("   Buy ", ErrorDescription(err));
       }
     }
    if (enterSell)
     {
      ticket=OrderSend(Symbol(),OP_SELL,InitLots,Bid,3,Bid+SL*Point+_spr,Bid-TP*Point,"First Sell",MN,0,Red);
      if (ticket<0) 
       {
        err=GetLastError();
        Print("   Sell ", ErrorDescription(err));
       }
     }
   }
  if (T>0 && n==0)
   {
    if (s==1)
     {
      double lts;
      if (InitLots==LastBuyLot)
       {
        lts=NormalizeDouble(LastBuyLot*Multiplier*1.5,2);
       } else
       {
        lts=NormalizeDouble(LastBuyLot*Multiplier,2);
       }        
      ticket=OrderSend(Symbol(),OP_SELLSTOP,lts,LastBuy-Step*Point,0,LastBuy-(Step-SL)*Point+_spr,LastBuy-(Step+TP)*Point,"Next Sell",MN,0,Red);
      if (ticket<0) 
       {
        err=GetLastError();
        Print("   SellStop ", ErrorDescription(err));
       }
     }
    if (s==2)
     {
      if (InitLots==LastSellLot)
       {
        lts=NormalizeDouble(LastSellLot*Multiplier*1.5,2);
       } else
       {
        lts=NormalizeDouble(LastSellLot*Multiplier,2);
       }        
      ticket=OrderSend(Symbol(),OP_BUYSTOP,lts,LastSell+Step*Point,0,LastSell+(Step-SL)*Point-_spr,LastSell+(Step+TP)*Point,"Next Buy",MN,0,Blue);
      if (ticket<0) 
       {
        err=GetLastError();
        Print("   BuyStop ", ErrorDescription(err));
       }
     }
   }
/*  if (T>1 && n==0)
   {
    for(i=OrdersTotal()-1;i>=0;i--)
     { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN && OrderTakeProfit()!=0)
       {
        OrderModify(OrderTicket(),OrderOpenPrice(),0,0,0,CLR_NONE);
       }
     }
   } */
/*  if (T>2)
   {
    double prof=0;
    for(i=OrdersTotal()-1;i>=0;i--)
     { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN)
       {
        prof=prof+OrderProfit()+OrderSwap();
       }
     } 
    double _tv=MarketInfo(Symbol(),MODE_TICKVALUE);
    double need_prof=_tv*Lot*NeedProf;
//    Print(" ",prof,"   ",need_prof);
    if (prof>=need_prof)
     {
      for(i=OrdersTotal()-1;i>=0;i--)
       { 
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN && OrderType()==OP_BUY)
         {
          OrderClose(OrderTicket(),OrderLots(),Bid,3,Green);
         }
        if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN && OrderType()==OP_SELL)
         {
          OrderClose(OrderTicket(),OrderLots(),Ask,3,Green);
         }
       } 
     }
   }*/
//----
  return(0);
 }
//+------------------------------------------------------------------+


